/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONFIG_H
#define CONFIG_H

#define MEDIA_LOCAL_FILES_TYPE "local"
#define PROFILES_MEDIA_FOLDER "profiles"
#define PHOTOS_MEDIA_FOLDER "photos"
#define VIDEOS_MEDIA_FOLDER "videos"
#define OUTGOING_MEDIA_FOLDER "outgoing"
#define PHOTO_MAX_DIMENSION 2048

#include <QString>
#include <QLoggingCategory>

Q_DECLARE_LOGGING_CATEGORY(TG_PLUGIN_LOGIC)

class Config
{
public:
    Config();
    ~Config();

    QString phoneNumber() const;
    QString configPath() const;
    QString publicKeyFile() const;
    QString databasePath();
    QString downloadsPath() const;
    void setPhoneNumber(const QString &phoneNumber);
    void setConfigPath(const QString &configPath);
    void setPublicKeyFile(const QString &publicKeyFile);
    void setOurId(qint32 ourId);
    void setDatabasePath(const QString &databasePath);
    void setDownloadsPath(const QString &downloadsPath);

private:
    QString mPhoneNumber;
    QString mConfigPath;
    QString mPublicKeyFile;
    QString mDatabasePath;
    QString mDownloadsPath;
};

#endif // CONFIG_H
