/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "contactsproxy.h"
#include "contactsmodel.h"
#include "core/settings.h"
#include <QRegExp>

ContactsProxy::ContactsProxy(QObject *parent) :
    SortProxyModel(parent) {
}

bool ContactsProxy::filterAcceptsRow(int sourceRow, const QModelIndex &sourceParent) const {
    QModelIndex index = sourceModel()->index(sourceRow, 0, sourceParent);

    QString firstName = sourceModel()->data(index, ContactsModel::FirstNameRole).toString();
    QString lastName = sourceModel()->data(index, ContactsModel::LastNameRole).toString();
    qint32 id = sourceModel()->data(index, ContactsModel::IdRole).toInt();

    bool notSelf = id != Settings::getInstance()->ourId();
    return notSelf && (firstName.contains(filterRegExp()) || lastName.contains(filterRegExp()));
}
