/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MESSAGESVIEW_H
#define MESSAGESVIEW_H

#include <QObject>
#include <QSqlQuery>
#include <QSqlError>
#include <QSqlDatabase>
#include "messageitem.h"
#include "dbmanager.h"
#include "view.h"

class MessagesView : public View
{
    Q_OBJECT

public:
    MessagesView(qint32 dialogId, qint32 peerType, const QSqlDatabase &database, QObject *parent = 0);
    void getNextPage();

Q_SIGNALS:
    void nextPage(const QList<MessageItem> &messages);

private:
    qint32 mDialogId;
    bool mIsChat;

    void createView();
};

#endif // MESSAGESVIEW_H
