#include "model.h"
#include <QSqlError>
#include <QSqlDriver>

Q_LOGGING_CATEGORY(TG_PLUGIN_MODELS, "tg.plugin.models")

Model::Model(QObject *parent) :
    QSqlQueryModel(parent) {
}

void Model::refresh() {
    setQuery(mQueryString);
}

QVariant Model::data(const QModelIndex &index, int role) const {

    if (!index.isValid()) {
        return QVariant();
    }

    QVariant value = QSqlQueryModel::data(index, role);

    if(role < Qt::UserRole) {
        value = QSqlQueryModel::data(index, role);
    } else {
        // use role int value as column index
        qint32 columnIndex = role - Qt::UserRole;
        QModelIndex modelIndex = this->index(index.row(), columnIndex);
        value = QSqlQueryModel::data(modelIndex, Qt::DisplayRole);
    }
    return value;
}
