/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Roberto Mier
 *      Tiago Herrmann
 */
#ifndef VIEW_H
#define VIEW_H

#include <QObject>
#include <QSqlDatabase>
#include <QSqlQuery>

class View : public QObject
{
    Q_OBJECT
public:
    explicit View(const QSqlDatabase &database, QObject *parent = 0);

    virtual void getNextPage() = 0;
    bool isValid() const;

Q_SIGNALS:
    void invalidated();

protected:
    QSqlQuery mQuery;
    qint32 mPageSize;
    qint32 mOffset;
};

#endif // VIEW_H
