/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLCHATPARTICIPANT_H
#define TLCHATPARTICIPANT_H

#include "tlobject.h"
#include <types/chatparticipant.h>

class TLChatParticipant : public TLObject, public ChatParticipant {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLChatParticipantType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(qint32 date READ date)
    Q_PROPERTY(qint32 userId READ userId)
    Q_PROPERTY(qint32 inviterId READ inviterId)

public:
    enum TLChatParticipantType {
        TypeChatParticipant = ChatParticipant::typeChatParticipant
    };

    explicit TLChatParticipant(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLChatParticipant(const TLChatParticipant &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLChatParticipant() {}

    void setData(const void *data) {
        ChatParticipant *obj = (ChatParticipant *)data;
        setClassType(obj->classType());
        setDate(obj->date());
        setUserId(obj->userId());
        setInviterId(obj->inviterId());
    }
};
Q_DECLARE_METATYPE(TLChatParticipant)

#endif // TLCHATPARTICIPANT_H
