/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLCONTACT_H
#define TLCONTACT_H

#include "tlobject.h"
#include <types/contact.h>

class TLContact : public TLObject, public Contact {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLContactType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(bool mutual READ mutual)
    Q_PROPERTY(qint32 userId READ userId)

public:
    enum TLContactType {
        TypeContact = Contact::typeContact
    };

    explicit TLContact(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLContact(const TLContact &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLContact() {}

    void setData(const void *data) {
        Contact *obj = (Contact *)data;
        setClassType(obj->classType());
        setMutual(obj->mutual());
        setUserId(obj->userId());
    }
};
Q_DECLARE_METATYPE(TLContact)

#endif // TLCONTACT_H
