/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLCONTACTBLOCKED_H
#define TLCONTACTBLOCKED_H

#include "tlobject.h"
#include <types/contactblocked.h>

class TLContactBlocked : public TLObject, public ContactBlocked {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLContactBlockedType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(qint32 date READ date)
    Q_PROPERTY(qint32 userId READ userId)

public:
    enum TLContactBlockedType {
        TypeContactBlocked = ContactBlocked::typeContactBlocked
    };

    explicit TLContactBlocked(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLContactBlocked(const TLContactBlocked &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLContactBlocked() {}

    void setData(const void *data) {
        ContactBlocked *obj = (ContactBlocked *)data;
        setClassType(obj->classType());
        setDate(obj->date());
        setUserId(obj->userId());
    }
};
Q_DECLARE_METATYPE(TLContactBlocked)

#endif // TLCONTACTBLOCKED_H
