/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLCONTACTSFOREIGNLINK_H
#define TLCONTACTSFOREIGNLINK_H

#include "tlobject.h"
#include <types/contactsforeignlink.h>

class TLContactsForeignLink : public TLObject, public ContactsForeignLink {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLContactsForeignLinkType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(bool hasPhone READ hasPhone)

public:
    enum TLContactsForeignLinkType {
        TypeContactsForeignLinkMutual = ContactsForeignLink::typeContactsForeignLinkMutual,
        TypeContactsForeignLinkRequested = ContactsForeignLink::typeContactsForeignLinkRequested,
        TypeContactsForeignLinkUnknown = ContactsForeignLink::typeContactsForeignLinkUnknown
    };

    explicit TLContactsForeignLink(QObject *parent = 0) : 
        TLObject(parent), 
        ContactsForeignLink(ContactsForeignLink::typeContactsForeignLinkUnknown) {
    }
    TLContactsForeignLink(const TLContactsForeignLink &other) :
        TLObject(other.parent()),
        ContactsForeignLink(other.classType()) {
        setData(&other);
    }
    ~TLContactsForeignLink() {}

    void setData(const void *data) {
        ContactsForeignLink *obj = (ContactsForeignLink *)data;
        setClassType(obj->classType());
        setHasPhone(obj->hasPhone());
    }
};
Q_DECLARE_METATYPE(TLContactsForeignLink)

#endif // TLCONTACTSFOREIGNLINK_H
