/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLCONTACTSTATUS_H
#define TLCONTACTSTATUS_H

#include "tlobject.h"
#include <types/contactstatus.h>

class TLContactStatus : public TLObject, public ContactStatus {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLContactStatusType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(qint32 expires READ expires)
    Q_PROPERTY(qint32 userId READ userId)

public:
    enum TLContactStatusType {
        TypeContactStatus = ContactStatus::typeContactStatus
    };

    explicit TLContactStatus(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLContactStatus(const TLContactStatus &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLContactStatus() {}

    void setData(const void *data) {
        ContactStatus *obj = (ContactStatus *)data;
        setClassType(obj->classType());
        setExpires(obj->expires());
        setUserId(obj->userId());
    }
};
Q_DECLARE_METATYPE(TLContactStatus)

#endif // TLCONTACTSTATUS_H
