/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLDCOPTION_H
#define TLDCOPTION_H

#include "tlobject.h"
#include <types/dcoption.h>

class TLDcOption : public TLObject, public DcOption {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLDcOptionType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(QString hostname READ hostname)
    Q_PROPERTY(QString ipAddress READ ipAddress)
    Q_PROPERTY(qint32 id READ id)
    Q_PROPERTY(qint32 port READ port)

public:
    enum TLDcOptionType {
        TypeDcOption = DcOption::typeDcOption
    };

    explicit TLDcOption(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLDcOption(const TLDcOption &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLDcOption() {}

    void setData(const void *data) {
        DcOption *obj = (DcOption *)data;
        setClassType(obj->classType());
        setHostname(obj->hostname());
        setIpAddress(obj->ipAddress());
        setId(obj->id());
        setPort(obj->port());
    }
};
Q_DECLARE_METATYPE(TLDcOption)

#endif // TLDCOPTION_H
