/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLIMPORTEDCONTACT_H
#define TLIMPORTEDCONTACT_H

#include "tlobject.h"
#include <types/importedcontact.h>

class TLImportedContact : public TLObject, public ImportedContact {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLImportedContactType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(qint32 userId READ userId)
    Q_PROPERTY(qint64 clientId READ clientId)

public:
    enum TLImportedContactType {
        TypeImportedContact = ImportedContact::typeImportedContact
    };

    explicit TLImportedContact(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLImportedContact(const TLImportedContact &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLImportedContact() {}

    void setData(const void *data) {
        ImportedContact *obj = (ImportedContact *)data;
        setClassType(obj->classType());
        setUserId(obj->userId());
        setClientId(obj->clientId());
    }
};
Q_DECLARE_METATYPE(TLImportedContact)

#endif // TLIMPORTEDCONTACT_H
