/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLOBJECT_H
#define TLOBJECT_H

#include <QObject>

class TLObject : public QObject {
    Q_OBJECT
public:
    explicit TLObject(QObject *parent = 0) : QObject(parent) {}

    /**
     * @brief setData sets the real data of the TLObject. Must be implemented in every inherited class in its way
     */
    virtual void setData(const void *) = 0;
};
Q_DECLARE_INTERFACE(TLObject,"Telegram.Plugin.TLObject/1.0")

#endif
