/*
 * Copyright 2014 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TLUPDATESSTATE_H
#define TLUPDATESSTATE_H

#include "tlobject.h"
#include <types/updatesstate.h>

class TLUpdatesState : public TLObject, public UpdatesState {
    Q_OBJECT
    Q_INTERFACES(TLObject)
    Q_ENUMS(TLUpdatesStateType)
    Q_PROPERTY(qint32 classType READ classType)
    Q_PROPERTY(qint32 date READ date)
    Q_PROPERTY(qint32 unreadCount READ unreadCount)
    Q_PROPERTY(qint32 pts READ pts)
    Q_PROPERTY(qint32 qts READ qts)
    Q_PROPERTY(qint32 seq READ seq)

public:
    enum TLUpdatesStateType {
        TypeUpdatesState = UpdatesState::typeUpdatesState
    };

    explicit TLUpdatesState(QObject *parent = 0) : 
        TLObject(parent) {
    }
    TLUpdatesState(const TLUpdatesState &other) :
        TLObject(other.parent()) {
        setData(&other);
    }
    ~TLUpdatesState() {}

    void setData(const void *data) {
        UpdatesState *obj = (UpdatesState *)data;
        setClassType(obj->classType());
        setDate(obj->date());
        setUnreadCount(obj->unreadCount());
        setPts(obj->pts());
        setQts(obj->qts());
        setSeq(obj->seq());
    }
};
Q_DECLARE_METATYPE(TLUpdatesState)

#endif // TLUPDATESSTATE_H
